// GUN 2
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _32
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 0, binding = 1, std430) restrict readonly buffer _34_36
{
    _32 _m0[];
} _36;

layout(set = 2, binding = 0, std140) uniform _79_81
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _81;

layout(set = 0, binding = 0, std140) uniform _123_125
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _125;

layout(set = 1, binding = 0, std140) uniform _173_175
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
} _175;

layout(set = 0, binding = 2, std430) restrict readonly buffer _392_394
{
    vec4 _m0[];
} _394;

layout(push_constant, std430) uniform _39_41
{
    int _m0;
    int _m1;
} _41;

layout(location = 0) in vec4 _70;
layout(location = 3) in vec4 _158;
layout(location = 9) in vec4 _412;
layout(location = 2) in vec4 _428;
layout(location = 10) out vec4 _1120;
layout(location = 11) out vec4 _1726;

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

mat4 _19(mat4 _17, mat4 _18)
{
    return _17 * _18;
}

void main()
{
    vec4 _31 = _36._m0[_41._m1]._m0;
    vec4 _49 = _36._m0[_41._m1]._m1;
    vec4 _54 = _36._m0[_41._m1]._m2;
    vec4 _60 = _36._m0[_41._m1]._m3;
    vec3 _68 = _70.xyz;
    vec4 _73;
    _73.x = (_68.x * _81._m11.x) + _81._m12.x;
    _73.y = (_68.y * _81._m11.y) + _81._m12.y;
    _73.z = (_68.z * _81._m11.z) + _81._m12.z;
    _73.w = 1.0;
    bool _120 = _81._m4.x != 0.0;
    bool _130;
    if (_120)
    {
        _130 = _125._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _130 = _120;
    }
    bool _137;
    if (_130)
    {
        _137 = _81._m5.x > 0.0;
    }
    else
    {
        _137 = _130;
    }
    if (_137)
    {
        vec3 _140 = vec3(_125._m0.xy, 0.0);
        float _148 = _81._m4.x;
        float _151 = _81._m4.y;
        float _154 = _81._m4.w;
        vec4 _157 = _158;
        float _160 = _81._m5.x;
        float _163 = _81._m5.y;
        float _166 = _81._m5.z;
        float _169 = _81._m5.w;
        vec4 _176 = _73;
        vec4 _178 = _175._m4;
        vec4 _172;
        _172.x = _12(_176, _178);
        vec4 _183 = _73;
        vec4 _185 = _175._m5;
        _172.y = _12(_183, _185);
        vec4 _191 = _73;
        vec4 _193 = _175._m6;
        _172.z = _12(_191, _193);
        _172.w = 1.0;
        float _199 = dot(_172.xyz, _140) * _160;
        float _206 = _157.z * _169;
        float _211 = _175._m4.w * _175._m5.w;
        float _217 = ((_125._m1.x * _81._m4.z) * _160) - _199;
        float _227 = (_157.x * 1.0) - _206;
        float _233 = sin(_217 - _227);
        float _238 = sin((_217 * 1.33000004291534423828125) - _227);
        float _245 = ((_233 + _238) * 0.25) + 0.5;
        _245 *= _245;
        float _256 = (_245 * (_151 - _148)) + _148;
        vec3 _264 = _140 * vec3(_256);
        float _269 = ((_157.y * 16.0) - _211) - _206;
        float _278 = sin(((_125._m1.x * 4.0) * _163) + _269);
        float _288 = cos(((_125._m1.x * 3.3299999237060546875) * _163) + _269);
        float _298 = (_278 + _288) * (-_157.w);
        vec3 _306 = vec3(_278 * _154, _288 * _154, _298 * _166) * vec3(_256);
        vec3 _320 = ((_264 + _306) * _125._m0.z) * _157.z;
        vec3 _333 = _172.xyz + _320;
        _172 = vec4(_333.x, _333.y, _333.z, _172.w);
        _172.w = 1.0;
        _73.x = dot(_172, _175._m12);
        _73.y = dot(_172, _175._m13);
        _73.z = dot(_172, _175._m14);
    }
    if (_81._m7.z != 0.0)
    {
        vec4 _360 = _73;
        vec4 _362 = vec4(0.0);
        vec4 _364 = vec4(0.0);
        vec4 _365 = vec4(0.0);
        uvec4 _368 = uvec4(uint(_175._m20.x + _81._m7.x)) + uvec4(_158 * 255.0);
        if (_81._m7.z == 1.0)
        {
            uint _388 = _368.x;
            _362 = _394._m0[(_388 * 3u) + 0u];
            _364 = _394._m0[(_388 * 3u) + 1u];
            _365 = _394._m0[(_388 * 3u) + 2u];
        }
        else
        {
            float _411 = _412.w * 255.100006103515625;
            vec4 _418;
            _418.y = _411 - (floor(_411 / 128.0) * 128.0);
            float _427 = _428.w * 255.100006103515625;
            _418.z = floor(_427 / 16.0);
            _418.w = _427 - (_418.z * 16.0);
            _418.y *= 0.00393700785934925079345703125;
            _418.z *= 0.02222222276031970977783203125;
            _418.w *= 0.01666666753590106964111328125;
            _418.x = 1.0 - ((_418.y + _418.z) + _418.w);
            for (uint _467 = 0u; _467 < 4u; _467++)
            {
                _362 += (_394._m0[(_368[_467] * 3u) + 0u] * _418[_467]);
            }
            for (uint _491 = 0u; _491 < 4u; _491++)
            {
                _364 += (_394._m0[(_368[_491] * 3u) + 1u] * _418[_491]);
            }
            for (uint _514 = 0u; _514 < 4u; _514++)
            {
                _365 += (_394._m0[(_368[_514] * 3u) + 2u] * _418[_514]);
            }
        }
        vec4 _537 = _360;
        vec4 _539 = _362;
        _73.x = _12(_537, _539);
        vec4 _543 = _360;
        vec4 _545 = _364;
        _73.y = _12(_543, _545);
        vec4 _549 = _360;
        vec4 _551 = _365;
        _73.z = _12(_549, _551);
        _73.w = 1.0;
    }
    vec4 _560 = _73;
    vec4 _562 = _31;
    gl_Position.x = _12(_560, _562);
    vec4 _567 = _73;
    vec4 _569 = _49;
    gl_Position.y = _12(_567, _569);
    vec4 _573 = _73;
    vec4 _575 = _54;
    gl_Position.z = _12(_573, _575);
    vec4 _579 = _73;
    vec4 _581 = _60;
    gl_Position.w = _12(_579, _581);
    mat4 _585 = mat4(vec4(_175._m4), vec4(_175._m5), vec4(_175._m6), vec4(_175._m3));
    mat4 _615 = mat4(vec4(_125._m2), vec4(_125._m3), vec4(_125._m4), vec4(_125._m5));
    mat4 _646 = _585;
    mat4 _648 = _615;
    mat4 _645 = _19(_646, _648);
    vec4 _651 = _645[0];
    vec4 _654 = _645[1];
    vec4 _657 = _645[2];
    vec4 _660 = _645[3];
    vec3 _663 = _70.xyz;
    vec4 _666;
    _666.x = (_663.x * _81._m11.x) + _81._m12.x;
    _666.y = (_663.y * _81._m11.y) + _81._m12.y;
    _666.z = (_663.z * _81._m11.z) + _81._m12.z;
    _666.w = 1.0;
    bool _697 = _81._m4.x != 0.0;
    bool _703;
    if (_697)
    {
        _703 = _125._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _703 = _697;
    }
    bool _709;
    if (_703)
    {
        _709 = _81._m5.x > 0.0;
    }
    else
    {
        _709 = _703;
    }
    if (_709)
    {
        vec3 _712 = vec3(_125._m0.xy, 0.0);
        float _719 = _81._m4.x;
        float _722 = _81._m4.y;
        float _725 = _81._m4.w;
        vec4 _728 = _158;
        float _730 = _81._m5.x;
        float _733 = _81._m5.y;
        float _736 = _81._m5.z;
        float _739 = _81._m5.w;
        vec4 _743 = _666;
        vec4 _745 = _175._m4;
        vec4 _742;
        _742.x = _12(_743, _745);
        vec4 _750 = _666;
        vec4 _752 = _175._m5;
        _742.y = _12(_750, _752);
        vec4 _757 = _666;
        vec4 _759 = _175._m6;
        _742.z = _12(_757, _759);
        _742.w = 1.0;
        float _765 = dot(_742.xyz, _712) * _730;
        float _772 = _728.z * _739;
        float _777 = _175._m4.w * _175._m5.w;
        float _783 = ((_125._m1.x * _81._m4.z) * _730) - _765;
        float _793 = (_728.x * 1.0) - _772;
        float _799 = sin(_783 - _793);
        float _804 = sin((_783 * 1.33000004291534423828125) - _793);
        float _810 = ((_799 + _804) * 0.25) + 0.5;
        _810 *= _810;
        float _819 = (_810 * (_722 - _719)) + _719;
        vec3 _827 = _712 * vec3(_819);
        float _832 = ((_728.y * 16.0) - _777) - _772;
        float _840 = sin(((_125._m1.x * 4.0) * _733) + _832);
        float _849 = cos(((_125._m1.x * 3.3299999237060546875) * _733) + _832);
        float _858 = (_840 + _849) * (-_728.w);
        vec3 _866 = vec3(_840 * _725, _849 * _725, _858 * _736) * vec3(_819);
        vec3 _880 = ((_827 + _866) * _125._m0.z) * _728.z;
        vec3 _893 = _742.xyz + _880;
        _742 = vec4(_893.x, _893.y, _893.z, _742.w);
        _742.w = 1.0;
        _666.x = dot(_742, _175._m12);
        _666.y = dot(_742, _175._m13);
        _666.z = dot(_742, _175._m14);
    }
    if (_81._m7.z != 0.0)
    {
        vec4 _917 = _666;
        vec4 _919 = vec4(0.0);
        vec4 _920 = vec4(0.0);
        vec4 _921 = vec4(0.0);
        uvec4 _922 = uvec4(uint(_175._m20.x + _81._m7.x)) + uvec4(_158 * 255.0);
        if (_81._m7.z == 1.0)
        {
            uint _939 = _922.x;
            _919 = _394._m0[(_939 * 3u) + 0u];
            _920 = _394._m0[(_939 * 3u) + 1u];
            _921 = _394._m0[(_939 * 3u) + 2u];
        }
        else
        {
            float _958 = _412.w * 255.100006103515625;
            vec4 _962;
            _962.y = _958 - (floor(_958 / 128.0) * 128.0);
            float _970 = _428.w * 255.100006103515625;
            _962.z = floor(_970 / 16.0);
            _962.w = _970 - (_962.z * 16.0);
            _962.y *= 0.00393700785934925079345703125;
            _962.z *= 0.02222222276031970977783203125;
            _962.w *= 0.01666666753590106964111328125;
            _962.x = 1.0 - ((_962.y + _962.z) + _962.w);
            for (uint _1006 = 0u; _1006 < 4u; _1006++)
            {
                _919 += (_394._m0[(_922[_1006] * 3u) + 0u] * _962[_1006]);
            }
            for (uint _1029 = 0u; _1029 < 4u; _1029++)
            {
                _920 += (_394._m0[(_922[_1029] * 3u) + 1u] * _962[_1029]);
            }
            for (uint _1052 = 0u; _1052 < 4u; _1052++)
            {
                _921 += (_394._m0[(_922[_1052] * 3u) + 2u] * _962[_1052]);
            }
        }
        vec4 _1075 = _917;
        vec4 _1077 = _919;
        _666.x = _12(_1075, _1077);
        vec4 _1081 = _917;
        vec4 _1083 = _920;
        _666.y = _12(_1081, _1083);
        vec4 _1087 = _917;
        vec4 _1089 = _921;
        _666.z = _12(_1087, _1089);
        _666.w = 1.0;
    }
    vec4 _1095 = _666;
    vec4 _1097 = _651;
    vec4 _1094;
    _1094.x = _12(_1095, _1097);
    vec4 _1101 = _666;
    vec4 _1103 = _654;
    _1094.y = _12(_1101, _1103);
    vec4 _1107 = _666;
    vec4 _1109 = _657;
    _1094.z = _12(_1107, _1109);
    vec4 _1113 = _666;
    vec4 _1115 = _660;
    _1094.w = _12(_1113, _1115);
    _1120 = _1094;
    mat4 _1122 = mat4(vec4(_175._m7), vec4(_175._m8), vec4(_175._m9), vec4(_175._m10));
    mat4 _1155 = mat4(vec4(_125._m6), vec4(_125._m7), vec4(_125._m8), vec4(_125._m9));
    mat4 _1186 = _1122;
    mat4 _1188 = _1155;
    mat4 _1185 = _19(_1186, _1188);
    vec4 _1191 = _1185[0];
    vec4 _1194 = _1185[1];
    vec4 _1197 = _1185[2];
    vec4 _1200 = _1185[3];
    vec3 _1203 = _70.xyz;
    vec4 _1206;
    _1206.x = (_1203.x * _81._m11.x) + _81._m12.x;
    _1206.y = (_1203.y * _81._m11.y) + _81._m12.y;
    _1206.z = (_1203.z * _81._m11.z) + _81._m12.z;
    _1206.w = 1.0;
    vec3 _1235 = vec3(0.0);
    bool _1239 = _81._m7.z == 1.0;
    bool _1245;
    if (_1239)
    {
        _1245 = _81._m7.w > 0.0;
    }
    else
    {
        _1245 = _1239;
    }
    if (_1245)
    {
        uvec4 _1248 = uvec4(_158 * 255.0);
        float _1252 = 7.6894684752915054559707641601563e-06;
        _1235.x = (((_1248.w & 128u) > 0u) ? (-1.0) : 1.0) * (_1252 * float(_1248.w & 127u));
        _1235.y = (((_1248.z & 128u) > 0u) ? (-1.0) : 1.0) * (_1252 * float(_1248.z & 127u));
        _1235.z = (((_1248.y & 128u) > 0u) ? (-1.0) : 1.0) * (_1252 * float(_1248.y & 127u));
    }
    vec3 _1299 = _1206.xyz - _1235;
    _1206 = vec4(_1299.x, _1299.y, _1299.z, _1206.w);
    bool _1304 = _81._m4.x != 0.0;
    bool _1310;
    if (_1304)
    {
        _1310 = _125._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _1310 = _1304;
    }
    bool _1316;
    if (_1310)
    {
        _1316 = _81._m5.x > 0.0;
    }
    else
    {
        _1316 = _1310;
    }
    if (_1316)
    {
        vec3 _1319 = vec3(_125._m0.xy, 0.0);
        float _1326 = _81._m4.x;
        float _1329 = _81._m4.y;
        float _1332 = _81._m4.w;
        vec4 _1335 = _158;
        float _1337 = _81._m5.x;
        float _1340 = _81._m5.y;
        float _1343 = _81._m5.z;
        float _1346 = _81._m5.w;
        vec4 _1350 = _1206;
        vec4 _1352 = _175._m4;
        vec4 _1349;
        _1349.x = _12(_1350, _1352);
        vec4 _1357 = _1206;
        vec4 _1359 = _175._m5;
        _1349.y = _12(_1357, _1359);
        vec4 _1364 = _1206;
        vec4 _1366 = _175._m6;
        _1349.z = _12(_1364, _1366);
        _1349.w = 1.0;
        float _1372 = dot(_1349.xyz, _1319) * _1337;
        float _1379 = _1335.z * _1346;
        float _1384 = _175._m4.w * _175._m5.w;
        float _1390 = ((_125._m1.x * _81._m4.z) * _1337) - _1372;
        float _1400 = (_1335.x * 1.0) - _1379;
        float _1406 = sin(_1390 - _1400);
        float _1411 = sin((_1390 * 1.33000004291534423828125) - _1400);
        float _1417 = ((_1406 + _1411) * 0.25) + 0.5;
        _1417 *= _1417;
        float _1426 = (_1417 * (_1329 - _1326)) + _1326;
        vec3 _1434 = _1319 * vec3(_1426);
        float _1439 = ((_1335.y * 16.0) - _1384) - _1379;
        float _1447 = sin(((_125._m1.x * 4.0) * _1340) + _1439);
        float _1456 = cos(((_125._m1.x * 3.3299999237060546875) * _1340) + _1439);
        float _1465 = (_1447 + _1456) * (-_1335.w);
        vec3 _1473 = vec3(_1447 * _1332, _1456 * _1332, _1465 * _1343) * vec3(_1426);
        vec3 _1487 = ((_1434 + _1473) * _125._m0.z) * _1335.z;
        vec3 _1500 = _1349.xyz + _1487;
        _1349 = vec4(_1500.x, _1500.y, _1500.z, _1349.w);
        _1349.w = 1.0;
        _1206.x = dot(_1349, _175._m12);
        _1206.y = dot(_1349, _175._m13);
        _1206.z = dot(_1349, _175._m14);
    }
    if (_81._m7.z != 0.0)
    {
        vec4 _1524 = _1206;
        vec4 _1526 = vec4(0.0);
        vec4 _1527 = vec4(0.0);
        vec4 _1528 = vec4(0.0);
        uvec4 _1529 = uvec4(uint(_175._m20.y + _81._m7.y)) + uvec4(_158 * 255.0);
        if (_81._m7.z == 1.0)
        {
            uint _1546 = _1529.x;
            _1526 = _394._m0[(_1546 * 3u) + 0u];
            _1527 = _394._m0[(_1546 * 3u) + 1u];
            _1528 = _394._m0[(_1546 * 3u) + 2u];
        }
        else
        {
            float _1565 = _412.w * 255.100006103515625;
            vec4 _1569;
            _1569.y = _1565 - (floor(_1565 / 128.0) * 128.0);
            float _1577 = _428.w * 255.100006103515625;
            _1569.z = floor(_1577 / 16.0);
            _1569.w = _1577 - (_1569.z * 16.0);
            _1569.y *= 0.00393700785934925079345703125;
            _1569.z *= 0.02222222276031970977783203125;
            _1569.w *= 0.01666666753590106964111328125;
            _1569.x = 1.0 - ((_1569.y + _1569.z) + _1569.w);
            for (uint _1613 = 0u; _1613 < 4u; _1613++)
            {
                _1526 += (_394._m0[(_1529[_1613] * 3u) + 0u] * _1569[_1613]);
            }
            for (uint _1636 = 0u; _1636 < 4u; _1636++)
            {
                _1527 += (_394._m0[(_1529[_1636] * 3u) + 1u] * _1569[_1636]);
            }
            for (uint _1659 = 0u; _1659 < 4u; _1659++)
            {
                _1528 += (_394._m0[(_1529[_1659] * 3u) + 2u] * _1569[_1659]);
            }
        }
        vec4 _1682 = _1524;
        vec4 _1684 = _1526;
        _1206.x = _12(_1682, _1684);
        vec4 _1688 = _1524;
        vec4 _1690 = _1527;
        _1206.y = _12(_1688, _1690);
        vec4 _1694 = _1524;
        vec4 _1696 = _1528;
        _1206.z = _12(_1694, _1696);
        _1206.w = 1.0;
    }
    vec4 _1702 = _1206;
    vec4 _1704 = _1191;
    vec4 _1701;
    _1701.x = _12(_1702, _1704);
    vec4 _1708 = _1206;
    vec4 _1710 = _1194;
    _1701.y = _12(_1708, _1710);
    vec4 _1714 = _1206;
    vec4 _1716 = _1197;
    _1701.z = _12(_1714, _1716);
    vec4 _1720 = _1206;
    vec4 _1722 = _1200;
    _1701.w = _12(_1720, _1722);
    _1726 = _1701;
    gl_Position.y = -gl_Position.y;

  // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}





