// Laser Scope
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 1, binding = 0, std140) uniform _32_34
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _34;

layout(set = 0, binding = 0, std140) uniform _73_75
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _75;

layout(set = 2, binding = 0, std140) uniform _136_138
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
} _138;

layout(set = 0, binding = 1, std430) restrict readonly buffer _208_210
{
    vec4 _m0[];
} _210;

layout(push_constant, std430) uniform _660_662
{
    int _m0;
    int _m1;
} _662;

layout(set = 2, binding = 1) uniform sampler2D _456;
layout(set = 0, binding = 2) uniform sampler2D _663;
layout(set = 2, binding = 2) uniform sampler2D _664;
layout(set = 2, binding = 3) uniform sampler2D _665;

layout(location = 0) in vec4 _127;
layout(location = 3) in vec4 _191;
layout(location = 9) in vec4 _228;
layout(location = 2) in vec4 _244;
layout(location = 5) out vec4 _426;
layout(location = 1) in vec2 _472;
layout(location = 2) out vec4 _530;
layout(location = 3) out vec4 _554;
layout(location = 4) out vec4 _624;

mat4 _19(mat4 _17, mat4 _18)
{
    return _17 * _18;
}

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

void main()
{
    mat4 _31 = mat4(vec4(_34._m0), vec4(_34._m1), vec4(_34._m2), vec4(_34._m3));
    mat4 _72 = mat4(vec4(_75._m0), vec4(_75._m1), vec4(_75._m2), vec4(_75._m3));
    mat4 _106 = _31;
    mat4 _108 = _72;
    mat4 _105 = _19(_106, _108);
    vec4 _111 = _105[0];
    vec4 _114 = _105[1];
    vec4 _117 = _105[2];
    vec4 _120 = _105[3];
    vec3 _125 = _127.xyz;
    vec4 _130;
    _130.x = (_125.x * _138._m0.x) + _138._m1.x;
    _130.y = (_125.y * _138._m0.y) + _138._m1.y;
    _130.z = (_125.z * _138._m0.z) + _138._m1.z;
    _130.w = 1.0;
    if (_138._m2.z != 0.0)
    {
        vec4 _175 = _130;
        vec4 _177 = vec4(0.0);
        vec4 _179 = vec4(0.0);
        vec4 _180 = vec4(0.0);
        uvec4 _183 = uvec4(uint(_34._m4.x + _138._m2.x)) + uvec4(_191 * 255.0);
        if (_138._m2.z == 1.0)
        {
            uint _204 = _183.x;
            _177 = _210._m0[(_204 * 3u) + 0u];
            _179 = _210._m0[(_204 * 3u) + 1u];
            _180 = _210._m0[(_204 * 3u) + 2u];
        }
        else
        {
            float _227 = _228.w * 255.100006103515625;
            vec4 _234;
            _234.y = _227 - (floor(_227 / 128.0) * 128.0);
            float _243 = _244.w * 255.100006103515625;
            _234.z = floor(_243 / 16.0);
            _234.w = _243 - (_234.z * 16.0);
            _234.y *= 0.00393700785934925079345703125;
            _234.z *= 0.02222222276031970977783203125;
            _234.w *= 0.01666666753590106964111328125;
            _234.x = 1.0 - ((_234.y + _234.z) + _234.w);
            for (uint _284 = 0u; _284 < 4u; _284++)
            {
                _177 += (_210._m0[(_183[_284] * 3u) + 0u] * _234[_284]);
            }
            for (uint _308 = 0u; _308 < 4u; _308++)
            {
                _179 += (_210._m0[(_183[_308] * 3u) + 1u] * _234[_308]);
            }
            for (uint _331 = 0u; _331 < 4u; _331++)
            {
                _180 += (_210._m0[(_183[_331] * 3u) + 2u] * _234[_331]);
            }
        }
        vec4 _354 = _175;
        vec4 _356 = _177;
        _130.x = _12(_354, _356);
        vec4 _360 = _175;
        vec4 _362 = _179;
        _130.y = _12(_360, _362);
        vec4 _366 = _175;
        vec4 _368 = _180;
        _130.z = _12(_366, _368);
        _130.w = 1.0;
    }
    vec4 _377 = _130;
    vec4 _379 = _111;
    gl_Position.x = _12(_377, _379);
    vec4 _384 = _130;
    vec4 _386 = _114;
    gl_Position.y = _12(_384, _386);
    vec4 _390 = _130;
    vec4 _392 = _117;
    gl_Position.z = _12(_390, _392);
    vec4 _396 = _130;
    vec4 _398 = _120;
    gl_Position.w = _12(_396, _398);
    vec4 _403 = _130;
    vec4 _405 = _34._m0;
    vec4 _402;
    _402.x = _12(_403, _405);
    vec4 _410 = _130;
    vec4 _412 = _34._m1;
    _402.y = _12(_410, _412);
    vec4 _417 = _130;
    vec4 _419 = _34._m2;
    _402.z = _12(_417, _419);
    _402.w = 1.0;
    _426 = _402;
    float _428 = _34._m5.w * 7.33300018310546875;
    float _434 = _75._m4.x + _428;
    vec2 _441 = vec2((_434 * _138._m3.x) * _34._m6.x, 0.25);
    float _452 = textureLod(_456, vec4(_441, 0.0, 0.0).xy, vec4(_441, 0.0, 0.0).w).x;
    vec2 _470 = _472;
    vec4 _474;
    _474.x = (_470.x * _138._m4.x) + _138._m4.z;
    _474.y = (_470.y * _138._m4.y) + _138._m4.w;
    _474 = vec4(_474.x, _474.y, _474.xy.x, _474.xy.y);
    _474 = vec4(_474.x, _474.y, vec2(0.0, 1.0).x, vec2(0.0, 1.0).y);
    float _500 = _75._m4.x * _138._m5.w;
    float _506 = floor(_500 * _138._m5.y) / _138._m5.y;
    _506 = fract(_506);
    float _517 = floor((_500 * 0.5) * _138._m5.x) / _138._m5.x;
    _517 = fract(_517);
    vec4 _539 = _474;
    vec4 _541 = vec4(1.0 / _138._m5.x, 0.0, 0.0, _138._m5.z * _452);
    _530.x = _12(_539, _541);
    vec4 _549 = _474;
    vec4 _551 = vec4(0.0, 1.0 / _138._m5.y, 0.0, _506);
    _530.y = _12(_549, _551);
    vec4 _556 = _474;
    vec4 _558 = vec4(1.0, 0.0, 0.0, 0.0);
    _554.z = _12(_556, _558);
    vec4 _562 = _474;
    vec4 _564 = vec4(0.0, 1.0, 0.0, 0.0);
    _554.w = _12(_562, _564);
    float _567 = _434 * _138._m6.w;
    _567 = fract(_567);
    vec4 _580 = _474;
    vec4 _582 = vec4(_138._m6.x, 0.0, 0.0, _567 * 0.3300000131130218505859375);
    _530.z = _12(_580, _582);
    vec4 _589 = _474;
    vec4 _591 = vec4(0.0, _138._m6.y, 0.0, _567);
    _530.w = _12(_589, _591);
    float _594 = _434 * _138._m7.w;
    _594 = fract(_594);
    vec4 _602 = _474;
    vec4 _604 = vec4(1.0, 0.0, 0.0, 0.0);
    _554.x = _12(_602, _604);
    vec4 _611 = _474;
    vec4 _613 = vec4(0.0, _138._m7.y, 0.0, _594);
    _554.y = _12(_611, _613);
    float _616 = _434 * _138._m8.w;
    _616 = fract(_616);
    vec4 _625 = _474;
    vec4 _627 = vec4(1.0, 0.0, 0.0, 0.0);
    _624.x = _12(_625, _627);
    vec4 _634 = _474;
    vec4 _636 = vec4(0.0, _138._m8.y, 0.0, _616);
    _624.y = _12(_634, _636);
    vec4 _643 = _474;
    vec4 _645 = vec4(_138._m9.x, 0.0, 0.0, 0.0);
    _624.z = _12(_643, _645);
    vec4 _651 = _474;
    vec4 _653 = vec4(0.0, _138._m9.y, 0.0, 0.0);
    _624.w = _12(_651, _653);
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
   if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


