// GUN 1
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _724
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _56_58
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _58;

layout(set = 0, binding = 1, std430) restrict readonly buffer _103_105
{
    uint _m0[];
} _105;

layout(set = 0, binding = 0, std140) uniform _247_249
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _249;

layout(set = 1, binding = 0, std140) uniform _297_299
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
} _299;

layout(set = 0, binding = 2, std430) restrict readonly buffer _512_514
{
    vec4 _m0[];
} _514;

layout(set = 0, binding = 3, std430) restrict readonly buffer _726_728
{
    _724 _m0[];
} _728;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1281_1283
{
    uint _m0[];
} _1283;

layout(set = 0, binding = 15, std140) uniform _1286_1288
{
    vec4 _m0[4096];
} _1288;

layout(set = 0, binding = 16, std140) uniform _1290_1292
{
    vec4 _m0[4096];
} _1292;

layout(set = 0, binding = 17, std140) uniform _1294_1296
{
    vec4 _m0[4096];
} _1296;

layout(set = 0, binding = 19, std140) uniform _1302_1304
{
    vec4 _m0[4096];
} _1304;

layout(set = 0, binding = 20, std140) uniform _1306_1308
{
    vec4 _m0[4096];
} _1308;

layout(set = 0, binding = 21, std140) uniform _1310_1312
{
    vec4 _m0[4096];
} _1312;

layout(set = 0, binding = 23, std140) uniform _1315_1317
{
    vec4 _m0[4095];
} _1317;

layout(set = 0, binding = 25, std140) uniform _1323_1325
{
    vec4 _m0[4096];
} _1325;

layout(push_constant, std430) uniform _71_73
{
    int _m0;
    int _m1;
} _73;

layout(set = 0, binding = 4) uniform sampler3D _1074;
layout(set = 0, binding = 5) uniform sampler3D _1153;
layout(set = 0, binding = 6) uniform sampler _1273;
layout(set = 0, binding = 7) uniform sampler _1274;
layout(set = 0, binding = 8) uniform sampler _1275;
layout(set = 0, binding = 9) uniform sampler _1276;
layout(set = 0, binding = 10) uniform sampler _1277;
layout(set = 0, binding = 11) uniform sampler _1278;
layout(set = 0, binding = 12) uniform sampler _1279;
layout(set = 0, binding = 18) uniform sampler2D _1300;
layout(set = 0, binding = 22) uniform sampler2D _1313;
layout(set = 0, binding = 24) uniform sampler2DShadow _1321;
layout(set = 0, binding = 26) uniform sampler2D _1326;

layout(location = 3) in vec4 _157;
layout(location = 15) out vec4 _172;
layout(location = 14) flat out uvec3 _180;
layout(location = 0) in vec4 _187;
layout(location = 2) in vec4 _220;
layout(location = 9) in vec4 _227;
layout(location = 3) out vec4 _777;
layout(location = 4) out vec4 _801;
layout(location = 5) out vec4 _824;
layout(location = 6) out vec4 _870;
layout(location = 1) in vec2 _878;
layout(location = 2) out vec4 _880;
layout(location = 12) in vec2 _900;
layout(location = 10) out vec4 _914;
layout(location = 11) out vec4 _915;
layout(location = 12) out vec4 _916;

float _22(vec4 _20, vec4 _21)
{
    return dot(_20, _21);
}

float _18(vec4 _16, vec4 _17)
{
    return dot(_16.xyz, _17.xyz);
}

vec3 _11(vec3 _10)
{
    return clamp(_10, vec3(0.0), vec3(1.0));
}

void main()
{
    vec4 _44 = vec4(0.0);
    vec3 _46 = vec3(0.0);
    uvec2 _51 = uvec2(0u);
    uint _55 = 0u;
    if (_58._m1.x > 0.0)
    {
        int _69 = int(_58._m2[_73._m0]);
        int _81 = gl_VertexIndex & 16777215;
        int _87 = _81 + _69;
        uint _91 = uint(_87 / 2);
        uint _95 = uint(16 * (_87 & 1));
        uint _101 = _105._m0[_91] >> _95;
        _51.x = _101 & 7u;
        _51.y = (_101 >> uint(3)) & 7u;
        _46.x = float((_101 >> uint(6)) & 63u) / 63.0;
        _46.y = 0.0;
        _46.z = float((_101 >> uint(12)) & 15u) / 15.0;
    }
    else
    {
        if (_58._m7.z == 0.0)
        {
            if (_58._m4.x == 0.0)
            {
                if (_157.w == 0.0)
                {
                    _51.x = uint(_157.x * 255.0);
                }
            }
        }
    }
    _172 = vec4(_46, 0.0);
    _180 = uvec3(_51.x, _51.y, 0u);
    vec3 _186 = _187.xyz;
    _44.x = (_186.x * _58._m11.x) + _58._m12.x;
    _44.y = (_186.y * _58._m11.y) + _58._m12.y;
    _44.z = (_186.z * _58._m11.z) + _58._m12.z;
    _44.w = 1.0;
    vec4 _219 = (_220 * 2.0) - vec4(1.0);
    vec4 _226 = (_227 * 2.0) - vec4(1.0);
    _226.w = (floor((_227.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    bool _244 = _58._m4.x != 0.0;
    bool _254;
    if (_244)
    {
        _254 = _249._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _254 = _244;
    }
    bool _261;
    if (_254)
    {
        _261 = _58._m5.x > 0.0;
    }
    else
    {
        _261 = _254;
    }
    if (_261)
    {
        vec3 _264 = vec3(_249._m0.xy, 0.0);
        float _273 = _58._m4.x;
        float _276 = _58._m4.y;
        float _279 = _58._m4.w;
        vec4 _282 = _157;
        float _284 = _58._m5.x;
        float _287 = _58._m5.y;
        float _290 = _58._m5.z;
        float _293 = _58._m5.w;
        vec4 _300 = _44;
        vec4 _302 = _299._m4;
        vec4 _296;
        _296.x = _22(_300, _302);
        vec4 _307 = _44;
        vec4 _309 = _299._m5;
        _296.y = _22(_307, _309);
        vec4 _314 = _44;
        vec4 _316 = _299._m6;
        _296.z = _22(_314, _316);
        _296.w = 1.0;
        float _322 = dot(_296.xyz, _264) * _284;
        float _329 = _282.z * _293;
        float _334 = _299._m4.w * _299._m5.w;
        float _340 = ((_249._m1.x * _58._m4.z) * _284) - _322;
        float _350 = (_282.x * 1.0) - _329;
        float _356 = sin(_340 - _350);
        float _361 = sin((_340 * 1.33000004291534423828125) - _350);
        float _368 = ((_356 + _361) * 0.25) + 0.5;
        _368 *= _368;
        float _379 = (_368 * (_276 - _273)) + _273;
        vec3 _387 = _264 * vec3(_379);
        float _392 = ((_282.y * 16.0) - _334) - _329;
        float _401 = sin(((_249._m1.x * 4.0) * _287) + _392);
        float _411 = cos(((_249._m1.x * 3.3299999237060546875) * _287) + _392);
        float _421 = (_401 + _411) * (-_282.w);
        vec3 _429 = vec3(_401 * _279, _411 * _279, _421 * _290) * vec3(_379);
        vec3 _443 = ((_387 + _429) * _249._m0.z) * _282.z;
        vec3 _456 = _296.xyz + _443;
        _296 = vec4(_456.x, _456.y, _456.z, _296.w);
        _296.w = 1.0;
        _44.x = dot(_296, _299._m12);
        _44.y = dot(_296, _299._m13);
        _44.z = dot(_296, _299._m14);
    }
    float _477 = 0.0;
    if (_58._m7.z != 0.0)
    {
        vec4 _483 = _44;
        vec4 _485 = vec4(0.0);
        vec4 _486 = vec4(0.0);
        vec4 _487 = vec4(0.0);
        uvec4 _490 = uvec4(uint(_299._m20.x + _58._m7.x)) + uvec4(_157 * 255.0);
        if (_58._m7.z == 1.0)
        {
            uint _508 = _490.x;
            _485 = _514._m0[(_508 * 3u) + 0u];
            _486 = _514._m0[(_508 * 3u) + 1u];
            _487 = _514._m0[(_508 * 3u) + 2u];
        }
        else
        {
            float _531 = _227.w * 255.100006103515625;
            vec4 _535;
            _535.y = _531 - (floor(_531 / 128.0) * 128.0);
            float _543 = _220.w * 255.100006103515625;
            _535.z = floor(_543 / 16.0);
            _535.w = _543 - (_535.z * 16.0);
            _535.y *= 0.00393700785934925079345703125;
            _535.z *= 0.02222222276031970977783203125;
            _535.w *= 0.01666666753590106964111328125;
            _535.x = 1.0 - ((_535.y + _535.z) + _535.w);
            for (uint _582 = 0u; _582 < 4u; _582++)
            {
                _485 += (_514._m0[(_490[_582] * 3u) + 0u] * _535[_582]);
            }
            for (uint _606 = 0u; _606 < 4u; _606++)
            {
                _486 += (_514._m0[(_490[_606] * 3u) + 1u] * _535[_606]);
            }
            for (uint _629 = 0u; _629 < 4u; _629++)
            {
                _487 += (_514._m0[(_490[_629] * 3u) + 2u] * _535[_629]);
            }
        }
        vec4 _652 = _483;
        vec4 _654 = _485;
        _44.x = _22(_652, _654);
        vec4 _658 = _483;
        vec4 _660 = _486;
        _44.y = _22(_658, _660);
        vec4 _664 = _483;
        vec4 _666 = _487;
        _44.z = _22(_664, _666);
        _44.w = 1.0;
        vec4 _671 = _219;
        vec4 _673 = _671;
        vec4 _675 = _485;
        _219.x = _18(_673, _675);
        vec4 _679 = _671;
        vec4 _681 = _486;
        _219.y = _18(_679, _681);
        vec4 _685 = _671;
        vec4 _687 = _487;
        _219.z = _18(_685, _687);
        vec4 _691 = _226;
        vec4 _693 = _691;
        vec4 _695 = _485;
        _226.x = _18(_693, _695);
        vec4 _699 = _691;
        vec4 _701 = _486;
        _226.y = _18(_699, _701);
        vec4 _705 = _691;
        vec4 _707 = _487;
        _226.z = _18(_705, _707);
    }
    vec3 _719 = cross(_219.xyz, _226.xyz) * _226.w;
    vec4 _711;
    _711 = vec4(_719.x, _719.y, _719.z, _711.w);
    _711.w = 0.0;
    vec4 _723 = _728._m0[_73._m1]._m0;
    vec4 _733 = _728._m0[_73._m1]._m1;
    vec4 _738 = _728._m0[_73._m1]._m2;
    vec4 _743 = _728._m0[_73._m1]._m3;
    vec4 _752 = _44;
    vec4 _754 = _723;
    gl_Position.x = _22(_752, _754);
    vec4 _759 = _44;
    vec4 _761 = _733;
    gl_Position.y = _22(_759, _761);
    vec4 _765 = _44;
    vec4 _767 = _738;
    gl_Position.z = _22(_765, _767);
    vec4 _771 = _44;
    vec4 _773 = _743;
    gl_Position.w = _22(_771, _773);
    vec4 _778 = _226;
    vec4 _780 = _299._m4;
    _777.x = _18(_778, _780);
    vec4 _785 = _711;
    vec4 _787 = _299._m4;
    _777.y = _18(_785, _787);
    vec4 _792 = _219;
    vec4 _794 = _299._m4;
    _777.z = _18(_792, _794);
    _777.w = _477;
    vec4 _802 = _226;
    vec4 _804 = _299._m5;
    _801.x = _18(_802, _804);
    vec4 _809 = _711;
    vec4 _811 = _299._m5;
    _801.y = _18(_809, _811);
    vec4 _816 = _219;
    vec4 _818 = _299._m5;
    _801.z = _18(_816, _818);
    _801.w = 0.0;
    vec4 _825 = _226;
    vec4 _827 = _299._m6;
    _824.x = _18(_825, _827);
    vec4 _832 = _711;
    vec4 _834 = _299._m6;
    _824.y = _18(_832, _834);
    vec4 _839 = _219;
    vec4 _841 = _299._m6;
    _824.z = _18(_839, _841);
    _824.w = 0.0;
    vec4 _848 = _44;
    vec4 _850 = _299._m4;
    vec4 _847;
    _847.x = _22(_848, _850);
    vec4 _855 = _44;
    vec4 _857 = _299._m5;
    _847.y = _22(_855, _857);
    vec4 _862 = _44;
    vec4 _864 = _299._m6;
    _847.z = _22(_862, _864);
    _847.w = 1.0;
    _870 = _847 - _249._m2;
    vec2 _876 = _878;
    _880.x = (_876.x * _58._m10.x) + _58._m10.z;
    _880.y = (_876.y * _58._m10.y) + _58._m10.w;
    _880.z = _900.x;
    _880.w = _900.y;
    vec3 _907 = _870.xyz + _249._m2.xyz;
    _914 = vec4(0.0);
    _915 = vec4(0.0);
    _916 = vec4(0.0);
    float _917 = float(_249._m3.x > 0.0);
    float _922 = _249._m3.x * _299._m15.x;
    bool _932 = _249._m3.y > 0.0;
    bool _939;
    if (!_932)
    {
        _939 = _249._m3.z > 0.0;
    }
    else
    {
        _939 = _932;
    }
    bool _946;
    if (!_939)
    {
        _946 = _249._m3.w > 0.0;
    }
    else
    {
        _946 = _939;
    }
    float _929 = float(_946);
    vec3 _948 = vec3(0.579999983310699462890625) * _249._m3.yzw;
    _914 = vec4(_249._m3.y, _249._m3.z, _249._m3.w, _948.x);
    _915 = vec4(_948.y, _948.z, _948.x, _948.y);
    _916 = vec4(_948.z, _948.x, _948.y, _948.z);
    if ((_917 > 0.0) && (_929 <= 0.0))
    {
        float _989 = -4096.0;
        float _991 = 4096.0;
        float _993 = 256.0;
        float _995 = 256.0;
        float _996 = 8.0;
        float _998 = 256.0;
        float _999 = 256.0;
        float _1000 = 30.0;
        vec3 _1002 = vec3(1.0 / _998, 1.0 / _999, 1.0 / _1000);
        vec3 _1010 = vec3(2.0 / _998, 2.0 / _999, 2.0 / _1000);
        vec3 _1018 = vec3(1.0 / _993, 1.0 / _995, 1.0 / _996);
        float _1026 = 1.0 / (_991 - _989);
        vec3 _1038 = (_907 - vec3(_989)) * _1026;
        vec3 _1031 = _11(_1038);
        vec4 _1040 = vec4(0.0);
        uvec3 _1042 = uvec3(0u);
        for (uint _1044 = 0u; _1044 < 13u; _1044++)
        {
            vec3 _1053 = vec3(0.5) + floor(vec3(2.0) * _1031);
            vec4 _1060 = vec4(_1018 * (vec3(_1042) + _1053), 0.0);
            _1040 = textureLod(_1074, _1060.xyz, _1060.w);
            _1031 = fract(_1031 * vec3(2.0));
            _1042 = uvec3(_1040.zyx * vec3(255.0));
            if (_1040.w > 0.0)
            {
                break;
            }
        }
        uint _1097 = (((uint(_1040.w * 255.0) << uint(24)) | (uint(_1040.z * 255.0) << uint(16))) | (uint(_1040.y * 255.0) << uint(8))) | uint(_1040.x * 255.0);
        uvec3 _1122 = uvec3((_1097 >> uint(19)) & 4095u, (_1097 >> uint(7)) & 4095u, _1097 & 127u);
        vec3 _1135 = vec3(2.0) * ((_1031 * vec3(0.5)) + vec3(0.25));
        vec4 _1141 = vec4(_1002 * (vec3(_1122) + _1135), 0.0);
        vec4 _1152 = textureLod(_1153, vec4(_1141.xy, _1141.z + (_1010.z * 0.0), 0.0).xyz, vec4(_1141.xy, _1141.z + (_1010.z * 0.0), 0.0).w) * _922;
        vec4 _1182 = textureLod(_1153, vec4(_1141.xy, _1141.z + (_1010.z * 1.0), 0.0).xyz, vec4(_1141.xy, _1141.z + (_1010.z * 1.0), 0.0).w) * _922;
        vec4 _1211 = textureLod(_1153, vec4(_1141.xy, _1141.z + (_1010.z * 2.0), 0.0).xyz, vec4(_1141.xy, _1141.z + (_1010.z * 2.0), 0.0).w) * _922;
        _914 = vec4(_1152.x, _1182.x, _1211.x, _1152.y);
        _915 = vec4(_1182.y, _1211.y, _1152.z, _1182.z);
        _916 = vec4(_1211.z, _1152.w, _1182.w, _1211.w);
    }
    gl_Position.y = -gl_Position.y;

  // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
  
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}




