// More Flares for some lights
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 0, binding = 0, std140) uniform _57_59
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _59;

layout(set = 1, binding = 0, std140) uniform _258_260
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
} _260;

layout(set = 2, binding = 0, std140) uniform _264_266
{
    vec4 _m0;
    vec4 _m1;
} _266;

layout(push_constant, std430) uniform _325_327
{
    int _m0;
    int _m1;
} _327;

layout(set = 0, binding = 1) uniform sampler2D _186;
layout(set = 2, binding = 1) uniform sampler2D _328;
layout(set = 2, binding = 2) uniform sampler2D _329;

layout(location = 12) in vec2 _73;
layout(location = 13) in uvec4 _91;
layout(location = 0) in vec4 _100;
layout(location = 2) out vec4 _239;
layout(location = 1) in vec2 _240;
layout(location = 3) in vec4 _244;
layout(location = 0) out vec4 _256;

float _21(float _17, vec4 _18, float _19, bool _20)
{
    float _36 = _18.w / (_17 + _18.z);
    return _36 * _19;
}

float _10(float _9)
{
    return _9 * ((_9 * ((_9 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

void main()
{
    float _52 = 0.0;
    vec2 _56 = _59._m0.xy * _59._m1.xy;
    vec2 _71 = (_73 * 0.5) + vec2(0.5);
    _71.y = 1.0 - _71.y;
    _71 *= _56;
    float _88 = float(_91.y) / 256.0;
    float _103 = _100.z;
    vec4 _107 = _59._m2;
    float _110 = 1.0;
    bool _111 = true;
    float _98 = _21(_103, _107, _110, _111) - _88;
    int _116 = 3;
    float _118 = 1.0 / float(((_116 * 2) + 1) * ((_116 * 2) + 1));
    vec2 _128 = _59._m3.xy * _59._m0.xy;
    vec2 _136 = _56 * (vec2(1.0) - (_59._m3.xy * 1.5));
    _52 = 0.0;
    for (int _146 = -_116; _146 <= _116; _146++)
    {
        for (int _157 = -_116; _157 <= _116; _157++)
        {
            vec2 _168 = (vec2(float(_157), float(_146)) * _128) + _71;
            _168 = clamp(_168, vec2(0.0), _136);
            float _182 = textureLod(_186, vec4(_168, 0.0, 0.0).xy, vec4(_168, 0.0, 0.0).w).x;
            float _202 = _182;
            vec4 _204 = _59._m2;
            float _207 = 1.0;
            bool _208 = true;
            float _201 = _21(_202, _204, _207, _208);
            // Flares Occlusion Compute
            // _52 += ((_201 > _98) ? _118 : 0.0);
            _52 += _118 * 0.5;
        }
    }
    vec4 _221 = vec4(_100.xy, 0.0, 1.0);
    gl_Position = _221;
    float _234 = float(_91.x) / 256.0;
    _239 = _240.xyxy;
    float _248 = _244.w;
    vec4 _243 = vec4(_244.xyz, _10(_248));
    _256 = ((((_243 * _260._m0) * _266._m0.x) * _260._m1.x) * vec4(_59._m4.xxx, 1.0)) * vec4(vec3(_234), 1.0);
    _256.w *= _52;
    if (true)
    {
        float _298 = 0.0039215688593685626983642578125;
        float _300 = 1.0 / (1.0 - _298);
        if (_256.w < _298)
        {
            gl_Position = vec4(vec3(0.0).x, vec3(0.0).y, vec3(0.0).z, gl_Position.w);
        }
        _256.w = (_256.w - _298) * _300;
    }
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x;// * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
}



