// Minimap UI
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 1, binding = 0, std140) uniform _43_45
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _45;

layout(set = 0, binding = 0, std140) uniform _93_95
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _95;

layout(push_constant, std430) uniform _241_243
{
    int _m0;
    int _m1;
} _243;

layout(set = 2, binding = 1) uniform sampler2D _247;
layout(set = 2, binding = 2) uniform sampler2D _248;

layout(location = 0) in vec4 _158;
layout(location = 2) out vec4 _187;
layout(location = 2) in vec4 _188;
layout(location = 12) in vec2 _196;
layout(location = 0) out vec4 _202;
layout(location = 3) in vec4 _203;
layout(location = 3) out vec4 _205;
layout(location = 9) in vec4 _206;
layout(location = 4) out vec4 _218;
layout(location = 1) in vec2 _219;

mat4 _23(mat4 _21, mat4 _22)
{
    return _21 * _22;
}

float _16(vec4 _14, vec4 _15)
{
    return dot(_14, _15);
}

vec4 _11(vec4 _10)
{
    return clamp(_10, vec4(0.0), vec4(1.0));
}

void main()
{
    vec4 _131;
    vec4 _134;
    vec4 _137;
    vec4 _140;
    if (_45._m0.x > 0.0)
    {
        mat4 _57 = mat4(vec4(_45._m1), vec4(_45._m2), vec4(_45._m3), vec4(_45._m4));
        mat4 _92 = mat4(vec4(_95._m0), vec4(_95._m1), vec4(_95._m2), vec4(_95._m3));
        mat4 _126 = _57;
        mat4 _128 = _92;
        mat4 _125 = _23(_126, _128);
        _131 = _125[0];
        _134 = _125[1];
        _137 = _125[2];
        _140 = _125[3];
    }
    else
    {
        _131 = _45._m1;
        _134 = _45._m2;
        _137 = _45._m3;
        _140 = _45._m4;
    }
    vec4 _159 = _158;
    vec4 _161 = _131;
    gl_Position.x = _16(_159, _161);
    vec4 _166 = _158;
    vec4 _168 = _134;
    gl_Position.y = _16(_166, _168);
    vec4 _172 = _158;
    vec4 _174 = _137;
    gl_Position.z = _16(_172, _174);
    vec4 _179 = _158;
    vec4 _181 = _140;
    gl_Position.w = _16(_179, _181);
    _187 = vec4(_188.x, _188.y, _196.x, _196.y);
    _202 = _203;
    vec4 _211 = _206 * vec4(1.0039370059967041015625);
    _205 = (_11(_211) * vec4(2.0)) - vec4(1.0);
    _218 = vec4(_219.x, _219.y, float((_188.z < 0.25) ? (-1) : 1), float((_188.w < 0.25) ? (-1) : 1));
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x * vk3d_params[VIEW].custom_params.x;
}


