// Reflections from water on surfaces
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

layout(set = 0, binding = 0, std140) uniform _68_70
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _70;

layout(set = 1, binding = 0, std140) uniform _87_89
{
    vec4 _m0;
} _89;

layout(push_constant, std430) uniform _498_500
{
    int _m0;
    int _m1;
} _500;

layout(set = 1, binding = 1) uniform sampler2D _189;

layout(location = 2) out vec4 _309;
layout(location = 3) out vec4 _463;

uint _10(inout uint _9)
{
    _9 &= 1431655765u;
    _9 = (_9 ^ (_9 >> uint(1))) & 858993459u;
    _9 = (_9 ^ (_9 >> uint(2))) & 252645135u;
    _9 = (_9 ^ (_9 >> uint(4))) & 16711935u;
    _9 = (_9 ^ (_9 >> uint(8))) & 65535u;
    return _9;
}

uvec2 _15(uint _14)
{
    uint _55 = _14 >> uint(0);
    uint _56 = _10(_55);
    uint _59 = _14 >> uint(1);
    uint _60 = _10(_59);
    return uvec2(_56, _60);
}

void main()
{
    float _66 = _70._m0.x;
    vec2 _77 = vec2(0.0);
    uint _80 = uint(_70._m0.x);
    bool _86 = (_89._m0.w > 0.0) ? true : false;
    if (_86)
    {
        uint _100 = uint(gl_VertexIndex) % _80;
        _77 = vec2(float(_100), float((uint(gl_VertexIndex) - _100) / _80)) / vec2(float(_80 - 1u));
    }
    else
    {
        uint _126 = uint(gl_VertexIndex);
        _77 = vec2(_15(_126)) / vec2(float(_80 - 1u));
    }
    float _134 = 1.0 / _89._m0.z;
    _77.x *= _134;
    _77.x += (_134 * _89._m0.x);
    float _153 = _70._m1.x * 1.57079637050628662109375;
    float _158 = _70._m2.x * 3.1415927410125732421875;
    vec3 _165 = normalize(vec3(sin(_153) * cos(_158), sin(_153) * sin(_158), cos(_153)));
    float _180 = 0.25;
    float _182 = 0.020369999110698699951171875;
    vec4 _185 = textureLod(_189, vec4(_77, 0.0, 0.0).xy, vec4(_77, 0.0, 0.0).w);
    vec4 _202 = textureLod(_189, vec4(_77 + (vec2(0.0, 1.0) / vec2(_66)), 0.0, 0.0).xy, vec4(_77 + (vec2(0.0, 1.0) / vec2(_66)), 0.0, 0.0).w);
    vec4 _224 = textureLod(_189, vec4(_77 + (vec2(-1.0, 0.0) / vec2(_66)), 0.0, 0.0).xy, vec4(_77 + (vec2(-1.0, 0.0) / vec2(_66)), 0.0, 0.0).w);
    vec3 _247 = normalize(cross(normalize(_202.xyz - _185.xyz), normalize(_224.xyz - _185.xyz)));
    vec3 _262 = _185.xyz + (normalize(refract(-_165, _247, _182)) * _180);
    vec2 _274 = vec2(0.0);
    _274 = (((_262.xy - _70._m3.xy) / vec2(16.0)) * 0.5) + vec2(0.5);
    gl_Position = vec4((_274 * 2.0) - vec2(1.0), 0.0, 1.0);
    gl_Position.y *= (-1.0);
    _309 = vec4(_247.x, _247.y, _247.z, _309.w);
    vec3 _313 = textureLod(_189, vec4(fract(_77 + (vec2(0.0, 2.0) / vec2(_66))), 0.0, 0.0).xy, vec4(fract(_77 + (vec2(0.0, 2.0) / vec2(_66))), 0.0, 0.0).w).xyz;
    vec3 _338 = textureLod(_189, vec4(fract(_77 + (vec2(-1.0, 1.0) / vec2(_66))), 0.0, 0.0).xy, vec4(fract(_77 + (vec2(-1.0, 1.0) / vec2(_66))), 0.0, 0.0).w).xyz;
    vec3 _363 = normalize(cross(normalize(_313 - _202.xyz), normalize(_338 - _202.xyz)));
    vec3 _376 = _202.xyz + (normalize(refract(-_165, _363, _182)) * _180);
    vec3 _388 = textureLod(_189, vec4(fract(_77 + (vec2(-1.0, 1.0) / vec2(_66))), 0.0, 0.0).xy, vec4(fract(_77 + (vec2(-1.0, 1.0) / vec2(_66))), 0.0, 0.0).w).xyz;
    vec3 _412 = textureLod(_189, vec4(fract(_77 + (vec2(-2.0, 0.0) / vec2(_66))), 0.0, 0.0).xy, vec4(fract(_77 + (vec2(-2.0, 0.0) / vec2(_66))), 0.0, 0.0).w).xyz;
    vec3 _438 = normalize(cross(normalize(_388 - _224.xyz), normalize(_412 - _224.xyz)));
    vec3 _451 = _224.xyz + (normalize(refract(-_165, _438, _182)) * _180);
    _463.x = (length(_185.xy - _224.xy) * length(_185.xy - _202.xy)) / 2.0;
    _463.y = (length(_262.xy - _451.xy) * length(_262.xy - _376.xy)) / 2.0;
    gl_Position.y = -gl_Position.y;
}

