
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

layout(set = 1, binding = 0, std140) uniform _32_34
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
} _34;

layout(set = 0, binding = 0, std140) uniform _73_75
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _75;

layout(set = 2, binding = 0, std140) uniform _136_138
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _138;

layout(set = 0, binding = 1, std430) restrict readonly buffer _436_438
{
    vec4 _m0[];
} _438;

layout(push_constant, std430) uniform _669_671
{
    int _m0;
    int _m1;
} _671;

layout(set = 0, binding = 2) uniform sampler _674;

layout(location = 0) in vec4 _127;
layout(location = 3) in vec4 _207;
layout(location = 9) in vec4 _456;
layout(location = 2) in vec4 _472;
layout(location = 1) in vec2 _632;
layout(location = 2) out vec4 _635;
layout(location = 12) in vec2 _654;
layout(location = 14) flat out uvec3 _663;

mat4 _19(mat4 _17, mat4 _18)
{
    return _17 * _18;
}

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

void main()
{
    mat4 _31 = mat4(vec4(_34._m0), vec4(_34._m1), vec4(_34._m2), vec4(_34._m3));
    mat4 _72 = mat4(vec4(_75._m0), vec4(_75._m1), vec4(_75._m2), vec4(_75._m3));
    mat4 _106 = _31;
    mat4 _108 = _72;
    mat4 _105 = _19(_106, _108);
    vec4 _111 = _105[0];
    vec4 _114 = _105[1];
    vec4 _117 = _105[2];
    vec4 _120 = _105[3];
    vec3 _125 = _127.xyz;
    vec4 _130;
    _130.x = (_125.x * _138._m0.x) + _138._m1.x;
    _130.y = (_125.y * _138._m0.y) + _138._m1.y;
    _130.z = (_125.z * _138._m0.z) + _138._m1.z;
    _130.w = 1.0;
    bool _172 = _138._m2.x != 0.0;
    bool _180;
    if (_172)
    {
        _180 = _75._m4.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _180 = _172;
    }
    bool _186;
    if (_180)
    {
        _186 = _138._m3.x > 0.0;
    }
    else
    {
        _186 = _180;
    }
    if (_186)
    {
        vec3 _189 = vec3(_75._m4.xy, 0.0);
        float _197 = _138._m2.x;
        float _200 = _138._m2.y;
        float _203 = _138._m2.w;
        vec4 _206 = _207;
        float _209 = _138._m3.x;
        float _212 = _138._m3.y;
        float _215 = _138._m3.z;
        float _218 = _138._m3.w;
        vec4 _222 = _130;
        vec4 _224 = _34._m0;
        vec4 _221;
        _221.x = _12(_222, _224);
        vec4 _229 = _130;
        vec4 _231 = _34._m1;
        _221.y = _12(_229, _231);
        vec4 _236 = _130;
        vec4 _238 = _34._m2;
        _221.z = _12(_236, _238);
        _221.w = 1.0;
        float _244 = dot(_221.xyz, _189) * _209;
        float _251 = _206.z * _218;
        float _256 = _34._m0.w * _34._m1.w;
        float _262 = ((_75._m5.x * _138._m2.z) * _209) - _244;
        float _273 = (_206.x * 1.0) - _251;
        float _279 = sin(_262 - _273);
        float _284 = sin((_262 * 1.33000004291534423828125) - _273);
        float _291 = ((_279 + _284) * 0.25) + 0.5;
        _291 *= _291;
        float _302 = (_291 * (_200 - _197)) + _197;
        vec3 _310 = _189 * vec3(_302);
        float _315 = ((_206.y * 16.0) - _256) - _251;
        float _324 = sin(((_75._m5.x * 4.0) * _212) + _315);
        float _334 = cos(((_75._m5.x * 3.3299999237060546875) * _212) + _315);
        float _344 = (_324 + _334) * (-_206.w);
        vec3 _352 = vec3(_324 * _203, _334 * _203, _344 * _215) * vec3(_302);
        vec3 _366 = ((_310 + _352) * _75._m4.z) * _206.z;
        vec3 _379 = _221.xyz + _366;
        _221 = vec4(_379.x, _379.y, _379.z, _221.w);
        _221.w = 1.0;
        _130.x = dot(_221, _34._m4);
        _130.y = dot(_221, _34._m5);
        _130.z = dot(_221, _34._m6);
    }
    if (_138._m4.z != 0.0)
    {
        vec4 _404 = _130;
        vec4 _406 = vec4(0.0);
        vec4 _408 = vec4(0.0);
        vec4 _409 = vec4(0.0);
        uvec4 _412 = uvec4(uint(_34._m7.x + _138._m4.x)) + uvec4(_207 * 255.0);
        if (_138._m4.z == 1.0)
        {
            uint _432 = _412.x;
            _406 = _438._m0[(_432 * 3u) + 0u];
            _408 = _438._m0[(_432 * 3u) + 1u];
            _409 = _438._m0[(_432 * 3u) + 2u];
        }
        else
        {
            float _455 = _456.w * 255.100006103515625;
            vec4 _462;
            _462.y = _455 - (floor(_455 / 128.0) * 128.0);
            float _471 = _472.w * 255.100006103515625;
            _462.z = floor(_471 / 16.0);
            _462.w = _471 - (_462.z * 16.0);
            _462.y *= 0.00393700785934925079345703125;
            _462.z *= 0.02222222276031970977783203125;
            _462.w *= 0.01666666753590106964111328125;
            _462.x = 1.0 - ((_462.y + _462.z) + _462.w);
            for (uint _511 = 0u; _511 < 4u; _511++)
            {
                _406 += (_438._m0[(_412[_511] * 3u) + 0u] * _462[_511]);
            }
            for (uint _535 = 0u; _535 < 4u; _535++)
            {
                _408 += (_438._m0[(_412[_535] * 3u) + 1u] * _462[_535]);
            }
            for (uint _558 = 0u; _558 < 4u; _558++)
            {
                _409 += (_438._m0[(_412[_558] * 3u) + 2u] * _462[_558]);
            }
        }
        vec4 _581 = _404;
        vec4 _583 = _406;
        _130.x = _12(_581, _583);
        vec4 _587 = _404;
        vec4 _589 = _408;
        _130.y = _12(_587, _589);
        vec4 _593 = _404;
        vec4 _595 = _409;
        _130.z = _12(_593, _595);
        _130.w = 1.0;
    }
    vec4 _604 = _130;
    vec4 _606 = _111;
    gl_Position.x = _12(_604, _606);
    vec4 _611 = _130;
    vec4 _613 = _114;
    gl_Position.y = _12(_611, _613);
    vec4 _617 = _130;
    vec4 _619 = _117;
    gl_Position.z = _12(_617, _619);
    vec4 _623 = _130;
    vec4 _625 = _120;
    gl_Position.w = _12(_623, _625);
    vec2 _630 = _632;
    _635.x = (_630.x * _138._m5.x) + _138._m5.z;
    _635.y = (_630.y * _138._m5.y) + _138._m5.w;
    _635.z = _654.x;
    _635.w = _654.y;
    _663 = uvec3(0u);
    gl_Position.y = -gl_Position.y;
}

