
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

layout(set = 2, binding = 0, std140) uniform _65_67
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _67;

layout(set = 1, binding = 0, std140) uniform _142_144
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
} _144;

layout(set = 0, binding = 1, std430) restrict readonly buffer _168_170
{
    vec4 _m0[];
} _170;

layout(set = 0, binding = 0, std140) uniform _441_443
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _443;

layout(push_constant, std430) uniform _557_559
{
    int _m0;
    int _m1;
} _559;

layout(set = 2, binding = 1) uniform sampler2D _563;

layout(location = 0) in vec4 _57;
layout(location = 2) in vec4 _102;
layout(location = 9) in vec4 _109;
layout(location = 3) in vec4 _151;
layout(location = 1) in vec2 _524;
layout(location = 2) out vec4 _527;
layout(location = 12) in vec2 _546;

float _21(vec4 _19, vec4 _20)
{
    return dot(_19, _20);
}

float _17(vec4 _15, vec4 _16)
{
    return dot(_15.xyz, _16.xyz);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

mat4 _28(mat4 _26, mat4 _27)
{
    return _26 * _27;
}

void main()
{
    vec3 _55 = _57.xyz;
    vec4 _60;
    _60.x = (_55.x * _67._m0.x) + _67._m1.x;
    _60.y = (_55.y * _67._m0.y) + _67._m1.y;
    _60.z = (_55.z * _67._m0.z) + _67._m1.z;
    _60.w = 1.0;
    vec4 _101 = (_102 * 2.0) - vec4(1.0);
    vec4 _108 = (_109 * 2.0) - vec4(1.0);
    _108.w = (floor((_109.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _125 = 0.0;
    if (_67._m2.z != 0.0)
    {
        vec4 _133 = _60;
        vec4 _135 = vec4(0.0);
        vec4 _137 = vec4(0.0);
        vec4 _138 = vec4(0.0);
        uvec4 _141 = uvec4(uint(_144._m0.x + _67._m2.x)) + uvec4(_151 * 255.0);
        if (_67._m2.z == 1.0)
        {
            uint _164 = _141.x;
            _135 = _170._m0[(_164 * 3u) + 0u];
            _137 = _170._m0[(_164 * 3u) + 1u];
            _138 = _170._m0[(_164 * 3u) + 2u];
        }
        else
        {
            float _188 = _109.w * 255.100006103515625;
            vec4 _192;
            _192.y = _188 - (floor(_188 / 128.0) * 128.0);
            float _200 = _102.w * 255.100006103515625;
            _192.z = floor(_200 / 16.0);
            _192.w = _200 - (_192.z * 16.0);
            _192.y *= 0.00393700785934925079345703125;
            _192.z *= 0.02222222276031970977783203125;
            _192.w *= 0.01666666753590106964111328125;
            _192.x = 1.0 - ((_192.y + _192.z) + _192.w);
            for (uint _240 = 0u; _240 < 4u; _240++)
            {
                _135 += (_170._m0[(_141[_240] * 3u) + 0u] * _192[_240]);
            }
            for (uint _264 = 0u; _264 < 4u; _264++)
            {
                _137 += (_170._m0[(_141[_264] * 3u) + 1u] * _192[_264]);
            }
            for (uint _287 = 0u; _287 < 4u; _287++)
            {
                _138 += (_170._m0[(_141[_287] * 3u) + 2u] * _192[_287]);
            }
        }
        vec4 _310 = _133;
        vec4 _312 = _135;
        _60.x = _21(_310, _312);
        vec4 _316 = _133;
        vec4 _318 = _137;
        _60.y = _21(_316, _318);
        vec4 _322 = _133;
        vec4 _324 = _138;
        _60.z = _21(_322, _324);
        _60.w = 1.0;
        vec4 _329 = _101;
        vec4 _331 = _329;
        vec4 _333 = _135;
        _101.x = _17(_331, _333);
        vec4 _337 = _329;
        vec4 _339 = _137;
        _101.y = _17(_337, _339);
        vec4 _343 = _329;
        vec4 _345 = _138;
        _101.z = _17(_343, _345);
        vec4 _349 = _108;
        vec4 _351 = _349;
        vec4 _353 = _135;
        _108.x = _17(_351, _353);
        vec4 _357 = _349;
        vec4 _359 = _137;
        _108.y = _17(_357, _359);
        vec4 _363 = _349;
        vec4 _365 = _138;
        _108.z = _17(_363, _365);
    }
    float _369 = length(_144._m1.xyz - _60.xyz);
    float _386 = abs(_369 - _144._m2.z) / _144._m2.x;
    float _377 = 1.0 - _10(_386);
    float _389 = ((_377 * _377) * _144._m2.y) * 0.00999999977648258209228515625;
    _60 += (_101 * vec4(_389, _389, _389, 0.0));
    mat4 _406 = mat4(vec4(_144._m3), vec4(_144._m4), vec4(_144._m5), vec4(_144._m6));
    mat4 _440 = mat4(vec4(_443._m0), vec4(_443._m1), vec4(_443._m2), vec4(_443._m3));
    mat4 _474 = _406;
    mat4 _476 = _440;
    mat4 _473 = _28(_474, _476);
    vec4 _479 = _473[0];
    vec4 _482 = _473[1];
    vec4 _485 = _473[2];
    vec4 _488 = _473[3];
    vec4 _495 = _60;
    vec4 _497 = _479;
    gl_Position.x = _21(_495, _497);
    vec4 _502 = _60;
    vec4 _504 = _482;
    gl_Position.y = _21(_502, _504);
    vec4 _508 = _60;
    vec4 _510 = _485;
    gl_Position.z = _21(_508, _510);
    vec4 _514 = _60;
    vec4 _516 = _488;
    gl_Position.w = _21(_514, _516);
    vec2 _522 = _524;
    _527.x = (_522.x * _67._m3.x) + _67._m3.z;
    _527.y = (_522.y * _67._m3.y) + _67._m3.w;
    _527.z = _546.x;
    _527.w = _546.y;
    gl_Position.y = -gl_Position.y;
}

